// Hard.cpp : implementation file
//

#include "stdafx.h"
#include "Guess.h"
#include "Hard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHard dialog


CHard::CHard(CWnd* pParent /*=NULL*/)
	: CDialog(CHard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHard)
	m_nInsert = 0;
	//}}AFX_DATA_INIT
}


void CHard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHard)
	DDX_Text(pDX, IDC_INSERT, m_nInsert);
	DDV_MinMaxInt(pDX, m_nInsert, 0, 9999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHard, CDialog)
	//{{AFX_MSG_MAP(CHard)
	ON_BN_CLICKED(IDC_CHECK, OnCheck)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHard message handlers

void CHard::OnCheck() 
{
	UpdateData();

	if(m_nInsert > 10000 || m_nInsert < 0)
		return;

	if ( CheckDiff(m_nInsert) == TRUE )
		HardCompare(m_nInsert);
	else
		AfxMessageBox("Please insert four different numbers!");	
}

BOOL CHard::CheckDiff(int nNumber)
{
	int temp[4];

	Split(nNumber, temp);

	for(int i = 0 ; i < 4 ; i++)
		for(int j = 0 ; j < 4 ; j++)
			if(i != j && temp[i] == temp[j])
					return FALSE;

	return TRUE;
}

void CHard::HardCompare(int nInsert)
{
	int nAB, temp[5040], tC[15], fAB, tCounter = 0;
	int i, j, nMax = 0;
	char szBuff[10];
	char buff[50];
	CString cSurplus;

	memset(tC, 0, sizeof(tC));
	memset(szBuff, 0, sizeof(szBuff));

	for ( i = 0 ; i < Surplus->m_nCounter ; i++ )
	{
		nAB = Compare(nInsert, Surplus->m_nSurplus[i]);
		switch (nAB)
		{
			case 0:
					tC[0]++;
					break;
			case 1:
					tC[1]++;
					break;
			case 2:
					tC[2]++;
					break;
			case 3:
					tC[3]++;
					break;
			case 4:
					tC[4]++;
					break;
			case 10:
					tC[5]++;
					break;
			case 11:
					tC[6]++;
					break;
			case 12:
					tC[7]++;
					break;
			case 13:
					tC[8]++;
					break;
			case 20:
					tC[9]++;
					break;
			case 21:
					tC[10]++;
					break;
			case 22:
					tC[11]++;
					break;
			case 30:
					tC[12]++;
					break;
			case 31:
					tC[13]++;
					break;
			case 40:
					tC[14]++;
					break;
			default:
					AfxMessageBox("Compare error!");
					break;
		}
	}

	for ( i = 0 ; i < 15 ; i++ )
	{
		if (tC[i] > nMax)
		{
			nMax = tC[i];
			switch (i)
			{
				case 0:
						fAB = 0;
						break;
				case 1:
						fAB = 1;
						break;
				case 2:
						fAB = 2;
						break;
				case 3:
						fAB = 3;
						break;
				case 4:
						fAB = 4;
						break;
				case 5:
						fAB = 10;
						break;
				case 6:
						fAB = 11;
						break;
				case 7:
						fAB = 12;
						break;
				case 8:
						fAB = 13;
						break;
				case 9:
						fAB = 20;
						break;
				case 10:
						fAB = 21;
						break;
				case 11:
						fAB = 22;
						break;
				case 12:
						fAB = 30;
						break;
				case 13:
						fAB = 31;
						break;
				case 14:
						fAB = 40;
						break;
				default:
						AfxMessageBox("Compare error!");
						break;
			}
		}
	}

	for ( i = 0 ; i < Surplus->m_nCounter ; i++ )
	{
		nAB = Compare(nInsert, Surplus->m_nSurplus[i]);
		if (nAB == fAB)
		{
			temp[tCounter] = Surplus->m_nSurplus[i];
			tCounter++;
		}
	}

	Surplus->m_nCounter = tCounter;

	int A = fAB/10;
	int B = fAB%10;

	_itoa(nInsert, szBuff, 10);
	if (nInsert < 1000)
	{
		for ( j = 9 ; j > 0 ; j-- )
		{
			szBuff[j] = szBuff[j - 1];
		}
		szBuff[0] = '0';
	}

	sprintf(szBuff, "%s %d A %d B \r\n", szBuff, A, B);
	((CEdit*)GetDlgItem(IDC_ANSWER))->ReplaceSel(szBuff, FALSE);

	for ( i = 0 ; i < tCounter ; i++ )
	{
		Surplus->m_nSurplus[i] = temp[i];
		_itoa(Surplus->m_nSurplus[i], szBuff, 10);

		if (Surplus->m_nSurplus[i] < 1000)
		{
			for ( j = 9 ; j > 0 ; j-- )
			{
				szBuff[j] = szBuff[j - 1];
			}
			szBuff[0] = '0';
		}

		sprintf(szBuff, "%s\r\n", szBuff);
		cSurplus += szBuff;
	}

	SetDlgItemText(IDC_SURPLUS, "");
	((CEdit*)GetDlgItem(IDC_SURPLUS))->ReplaceSel(cSurplus, FALSE);
	memset(szBuff, 0, sizeof(szBuff));

	if (fAB == 40)
	{
		_itoa(Surplus->m_nSurplus[0], szBuff, 10);

		if (Surplus->m_nSurplus[0] < 1000)
		{
			for ( j = 9 ; j > 0 ; j-- )
			{
				szBuff[j] = szBuff[j - 1];
			}
			szBuff[0] = '0';
		}

		sprintf(buff, "Congratulation! The answer is %s!", szBuff);
		AfxMessageBox(buff);
		if ( AfxMessageBox("Do you want to continute?", MB_YESNO) == IDYES )
		{
			SendMessage(WM_COMMAND, IDC_RESET);
		}
	}
}

void CHard::Split(int nSource, int *nDirect)
{
	nDirect[0] = nSource/1000;
	nDirect[1] = (nSource/100) % 10;
	nDirect[2] = (nSource%100) / 10;
	nDirect[3] = nSource%10;
}

BOOL CHard::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Surplus = new CSurplus();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHard::OnDestroy() 
{
	delete Surplus;
	CDialog::OnDestroy();
}

int CHard::Compare(int nGoal, int nInsert)
{
	int tGoal[4], tInsert[4];
	int tempA = 0, tempB = 0;
	int nAnswer;

	Split(nGoal, tGoal);
	Split(nInsert, tInsert);

	for ( int i = 0 ; i < 4 ; i++ )
		for ( int j = 0 ; j < 4 ; j++ )
			if ( tGoal[i] == tInsert[j] )
				if ( i == j )
					tempA++;
				else
					tempB++;

	nAnswer = 10*tempA + tempB;
	return nAnswer;
}

void CHard::OnReset() 
{
	SetDlgItemText(IDC_GOAL, "");
	SetDlgItemText(IDC_INSERT, "0");
	SetDlgItemText(IDC_ANSWER, "");
	SetDlgItemText(IDC_SURPLUS, "");

	delete Surplus;
	Surplus = new CSurplus;
}

void CHard::OnOK() 
{
	SendMessage(WM_COMMAND, IDC_CHECK);
	//CDialog::OnOK();
}

void CHard::OnCancel() 
{
//	CDialog::OnCancel();
}
