// Surplus.cpp: implementation of the CSurplus class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Guess.h"
#include "Surplus.h"

#include "GuessDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSurplus::CSurplus()
{
	m_nCounter = 5040;
	memset(m_nSurplus, 0, sizeof(m_nSurplus));

	int i, j = 0;

	for ( i = 0 ; i < 10000 ; i++ )
	{
		if (Check(i) == TRUE)
		{
			m_nSurplus[j] = i;
			j++;
		}
	}
}

CSurplus::~CSurplus()
{

}

BOOL CSurplus::Check(int nNumber)
{
	int temp[4];

	Split(nNumber, temp);

	if ( temp[0] == temp[1] || temp[0] == temp[2] || temp[0] == temp[3] || temp[1] == temp[2] || temp[1] == temp[3]	|| temp[2] == temp[3] )
		return FALSE;

	return TRUE;
}

void CSurplus::Split(int nSource, int *nDirect)
{
	nDirect[0] = nSource/1000;
	nDirect[1] = (nSource/100) % 10;
	nDirect[2] = (nSource%100) / 10;
	nDirect[3] = nSource%10;
}