// TabCreate.cpp : implementation file
//

#include "stdafx.h"
#include "Guess.h"
#include "TabCreate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabCreate

CTabCreate::CTabCreate()
{
	m_dDlg[0] = new CHard;
	m_dDlg[1] = new CEasy;

	m_nTabNumber = 2;
	m_nSelect = 0;
}

CTabCreate::~CTabCreate()
{
	for(int i = 0 ; i < m_nTabNumber ; i++)
		delete m_dDlg[i];
}


BEGIN_MESSAGE_MAP(CTabCreate, CTabCtrl)
	//{{AFX_MSG_MAP(CTabCreate)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabCreate message handlers

void CTabCreate::Init()
{
	m_dDlg[0]->Create(IDD_HARD, this);
	m_dDlg[1]->Create(IDD_EASY, this);

	m_dDlg[0]->ShowWindow(SW_SHOW);
	m_dDlg[1]->ShowWindow(SW_HIDE);

	SetSize();
}

void CTabCreate::SetSize()
{
	CRect tabRect, itemRect;
	int nX, nY, nXc, nYc;

	GetClientRect(&tabRect);
	GetItemRect(0, &itemRect);

	nX = itemRect.left;
	nY = itemRect.bottom + 1;
	nXc = tabRect.right - itemRect.left - 1;
	nYc = tabRect.bottom - nY - 1;

	m_dDlg[0]->SetWindowPos(&wndTop, nX, nY, nXc, nYc, SWP_SHOWWINDOW);

	for(int nCount = 1 ; nCount < m_nTabNumber ; nCount++)
	{
		m_dDlg[nCount]->SetWindowPos(&wndTop, nX, nY, nXc, nYc, SWP_HIDEWINDOW);
	}
}

void CTabCreate::OnSelchange(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int tempSel = GetCurSel();

	if(tempSel != m_nSelect)
	{
		m_dDlg[m_nSelect]->ShowWindow(SW_HIDE);
		m_dDlg[tempSel]->ShowWindow(SW_SHOW);
		m_nSelect = tempSel;
	}
	*pResult = 0;
}
